OSDN Git Service

c21c1b94de1312c750f9e32352581b09d9c1a38e
[pf3gnuchains/gcc-fork.git] / maintainer-scripts / gcc_release
1 #! /bin/sh
2
3 ########################################################################
4 #
5 # File:   gcc_release
6 # Author: Jeffrey Law, Bernd Schmidt, Mark Mitchell
7 # Date:   2001-05-25
8 #
9 # Contents:
10 #   Script to create a GCC release.
11 #
12 # Copyright (c) 2001, 2002 Free Software Foundation.
13 #
14 # This file is part of GCC.
15 #
16 # GCC is free software; you can redistribute it and/or modify
17 # it under the terms of the GNU General Public License as published by
18 # the Free Software Foundation; either version 2, or (at your option)
19 # any later version.
20 #
21 # GCC is distributed in the hope that it will be useful,
22 # but WITHOUT ANY WARRANTY; without even the implied warranty of
23 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
24 # GNU General Public License for more details.
25 #
26 # You should have received a copy of the GNU General Public License
27 # along with GCC; see the file COPYING.  If not, write to
28 # the Free Software Foundation, 59 Temple Place - Suite 330,
29 # Boston, MA 02111-1307, USA.
30 #
31 ########################################################################
32
33 ########################################################################
34 # Notes
35 ########################################################################
36
37 # Here is an example usage of this script, to create a GCC 3.0.2
38 # prerelease:
39 #
40 #   gcc_release -r 3.0.2
41 #
42 # This script will automatically use the head of the release branch
43 # to generate the release.
44
45 ########################################################################
46 # Functions
47 ########################################################################
48
49 # Issue the error message given by $1 and exit with a non-zero
50 # exit code.
51
52 error() {
53     echo "gcc_release: error: $1"
54     exit 1
55 }
56
57 # Issue the informational message given by $1.
58
59 inform() {
60     echo "gcc_release: $1"
61 }
62
63 # Issue a usage message explaining how to use this script.
64
65 usage() {
66 cat <<EOF
67 gcc_release -r release [-f] [further options]
68 gcc_release -s name:cvsbranch [further options]
69
70 Options:
71
72   -r release           Version of the form X.Y or X.Y.Z.
73   -s name:cvsbranch    Create a snapshot, not a real release.
74
75   -d destination       Local working directory where we will build the release
76                        (default=${HOME}).
77   -f                   Create a final release (and update ChangeLogs,...).
78   -l                   Indicate that we are running on gcc.gnu.org.
79   -p previous-tarball  Location of a previous tarball (to generate diff files).
80   -t tag               Tag to mark the release in CVS.
81   -u username          Username for upload operations.
82 EOF
83     exit 1
84 }
85
86 # Change to the directory given by $1.
87
88 changedir() {
89   cd $1 || \
90     error "Could not change directory to $1"
91 }
92
93 # Each of the arguments is a directory name, relative to the top
94 # of the source tree.  Return another name for that directory, relative
95 # to the working directory.
96
97 adjust_dirs() {
98   for x in $@; do
99     echo `basename ${SOURCE_DIRECTORY}`/$x
100   done
101 }
102
103 # Build the source tree that will be the basis for the release
104 # in ${WORKING_DIRECTORY}/gcc-${RELEASE}.
105
106 build_sources() {
107   # If the WORKING_DIRECTORY already exists, do not risk destroying it.
108   if [ -r ${WORKING_DIRECTORY} ]; then
109     error "\`${WORKING_DIRECTORY}' already exists"
110   fi
111   # Create the WORKING_DIRECTORY.
112   mkdir "${WORKING_DIRECTORY}" \
113     || error "Could not create \`${WORKING_DIRECTORY}'"
114   changedir "${WORKING_DIRECTORY}"
115
116   # If this is a final release, make sure that the ChangeLogs
117   # and version strings are updated.
118   if [ ${FINAL} -ne 0 ]; then
119     inform "Updating ChangeLogs and version files"
120
121     ${CVS} co -d "`basename ${SOURCE_DIRECTORY}`" \
122            -r ${CVSBRANCH} gcc || \
123            error "Could not check out release sources"
124     for x in `find ${SOURCE_DIRECTORY} -name ChangeLog`; do
125       # Update this ChangeLog file only if it does not yet contain the
126       # entry we are going to add.  (This is a safety net for repeated
127       # runs of this script for the same release.)
128       if ! grep "GCC ${RELEASE} released." ${x} > /dev/null ; then       
129         cat - ${x} > ${x}.new <<EOF
130 ${LONG_DATE}  Release Manager
131
132         * GCC ${RELEASE} released.
133
134 EOF
135         mv ${x}.new ${x} || \
136             error "Could not update ${x}"
137         (changedir `dirname ${x}` && \
138             ${CVS} ci -m 'Mark ChangeLog' `basename ${x}`) || \
139             error "Could not commit ${x}"
140       fi
141     done
142
143     # Update `gcc/version.c'.
144     for x in gcc/version.c; do 
145       y=`basename ${x}`
146       (changedir `dirname ${SOURCE_DIRECTORY}/${x}` && \
147           sed -e 's|version_string\[\] = \".*\"|version_string\[\] = \"'${RELEASE}'\"|g' < ${y} > ${y}.new && \
148           mv ${y}.new ${y} && \
149           ${CVS} ci -m 'Update version' ${y}) || \
150           error "Could not update ${x}"
151     done
152
153     # Make sure we tag the sources for a final release.
154     TAG="gcc_`echo ${RELEASE} | tr . _`_release"
155
156     rm -rf ${SOURCE_DIRECTORY}
157   fi
158
159   # Tag the sources.
160   if [ -n "${TAG}" ]; then
161     inform "Tagging sources as ${TAG}"
162     ${CVS} rtag -r ${CVSBRANCH} -F ${TAG} gcc || \
163       error "Could not tag sources"
164     EXPORTTAG="-r${TAG}"
165     EXPORTDATE=""
166   else
167     if [ ${CVSBRANCH} != "HEAD" ]; then
168       EXPORTTAG="-r${CVSBRANCH}"
169     else
170       # HEAD is the default branch, no need to specify it.
171       EXPORTTAG=""
172     fi
173     EXPORTDATE="-D`date -u +"%Y-%m-%d %H:%M"` UTC"
174   fi
175
176   # Export the current sources.
177   inform "Retrieving sources (cvs export ${EXPORTTAG} ${EXPORTDATE} gcc)"
178
179   if [ -z "${EXPORTTAG}" ]; then
180     ${CVS} export -d "`basename ${SOURCE_DIRECTORY}`" \
181        "${EXPORTDATE}" gcc || \
182       error "Could not retrieve sources"
183   elif [ -z "${EXPORTDATE}" ]; then
184     ${CVS} export -d "`basename ${SOURCE_DIRECTORY}`" \
185        "${EXPORTTAG}" gcc || \
186       error "Could not retrieve sources"
187   else
188     error "Cannot specify -r and -D at the same time"
189   fi
190
191   # Run gcc_update on them to set up the timestamps nicely, and (re)write
192   # the LAST_UPDATED file containing the CVS tag/date used.
193   changedir "gcc-${RELEASE}"
194   contrib/gcc_update --touch
195   echo "Obtained from CVS: ${EXPORTTAG} ${EXPORTDATE}" > LAST_UPDATED
196
197   # Obtain some documentation files from the wwwdocs module.
198   inform "Retrieving HTML documentation"
199   changedir "${WORKING_DIRECTORY}"
200   for x in bugs faq; do
201     (${CVS} export -r HEAD wwwdocs/htdocs/${x}.html && \
202      cp ${WORKING_DIRECTORY}/wwwdocs/htdocs/${x}.html \
203         ${SOURCE_DIRECTORY}) || \
204       error "Could not retrieve ${x}.html"
205   done
206
207   inform "Generating plain-text documentation from HTML"
208   changedir "${SOURCE_DIRECTORY}"
209   for file in *.html; do
210     newfile=`echo $file | sed -e 's/.html//' | tr "[:lower:]" "[:upper:]"`
211     (${ENV} TERM=vt100 lynx -dump $file \
212        | sed -e "s#file://localhost`/bin/pwd`\(.*\)#http://gcc.gnu.org\1#g" \
213        > $newfile) || \
214      error "Could not generate text-only version of ${file}"
215   done
216
217   # For a prerelease or real release, we need to generate additional
218   # files not present in CVS.
219   changedir "${SOURCE_DIRECTORY}"
220   if [ $SNAPSHOT -ne 1 ]; then
221     # Generate the documentation.
222     inform "Building install docs"
223     SOURCEDIR=${SOURCE_DIRECTORY}/gcc/doc
224     DESTDIR=${SOURCE_DIRECTORY}/INSTALL
225     export SOURCEDIR
226     export DESTDIR
227     ${SOURCE_DIRECTORY}/gcc/doc/install.texi2html
228
229     # Regenerate the NEWS file.
230     contrib/gennews > gcc/NEWS || \
231       error "Could not regenerate NEWS files"
232
233     # Now, we must build the compiler in order to create any generated
234     # files that are supposed to go in the source directory.  This is
235     # also a good sanity check to make sure that the release builds
236     # on at least one platform.
237     inform "Building compiler"
238     OBJECT_DIRECTORY=../objdir
239     contrib/gcc_build -d ${SOURCE_DIRECTORY} -o ${OBJECT_DIRECTORY} \
240       -c "--enable-generated-files-in-srcdir" build || \
241       error "Could not rebuild GCC"
242   fi
243
244   # Move message catalogs to source directory.
245   mv ../objdir/gcc/po/*.gmo gcc/po/
246
247   # Create a `.brik' file to use for checking the validity of the
248   # release.
249   changedir "${SOURCE_DIRECTORY}"
250   BRIK_FILE=`mktemp /tmp/gcc_release.XXXXXXX`
251   ((find . -type f | sort > $BRIK_FILE) && \
252        brik -Gb -f ${BRIK_FILE} > .brik && \
253        rm ${BRIK_FILE}) || \
254      error "Could not compute brik checksum"
255 }
256
257 # Buid a single tarfile.  The first argument is the name of the name
258 # of the tarfile to build, without any suffixes.  They will be added
259 # automatically.  The rest of the arguments are the files or
260 # directories to include.
261
262 build_tarfile() {
263   # Get the name of the destination tar file.
264   TARFILE="$1.tar.bz2"
265   shift
266
267   # Build the tar file itself.
268   (${TAR} cf - "$@" | ${BZIP2} > ${TARFILE}) || \
269     error "Could not build tarfile"
270   FILE_LIST="${FILE_LIST} ${TARFILE}"
271 }
272
273 # Build the various tar files for the release.
274
275 build_tarfiles() {
276   inform "Building tarfiles"
277
278   changedir "${WORKING_DIRECTORY}"
279
280   # The GNU Coding Standards specify that all files should
281   # world readable.
282   chmod -R a+r ${SOURCE_DIRECTORY}
283   # And that all directories have mode 777.
284   find ${SOURCE_DIRECTORY} -type d -exec chmod 777 {} \;
285  
286   # Build one huge tarfile for the entire distribution.
287   build_tarfile gcc-${RELEASE} `basename ${SOURCE_DIRECTORY}`
288
289   # Now, build one for each of the languages.
290   build_tarfile gcc-ada-${RELEASE} ${ADA_DIRS}
291   build_tarfile gcc-g++-${RELEASE} ${CPLUSPLUS_DIRS}
292   build_tarfile gcc-g77-${RELEASE} ${FORTRAN_DIRS}
293   build_tarfile gcc-java-${RELEASE} ${JAVA_DIRS}
294   build_tarfile gcc-objc-${RELEASE} ${OBJECTIVEC_DIRS}
295   build_tarfile gcc-testsuite-${RELEASE} ${TESTSUITE_DIRS}
296    
297   # The core is everything else.
298   EXCLUDES=""
299   for x in ${ADA_DIRS} ${CPLUSPLUS_DIRS} ${FORTRAN_DIRS} \
300            ${JAVA_DIRS} ${OBJECTIVEC_DIRS} ${TESTSUITE_DIRS}; do
301     EXCLUDES="${EXCLUDES} --exclude $x"
302   done
303   build_tarfile gcc-core-${RELEASE} ${EXCLUDES} \
304     `basename ${SOURCE_DIRECTORY}`
305 }
306
307 # Build .gz files.
308 build_gzip() {
309   for f in ${FILE_LIST}; do
310     target=${f%.bz2}.gz
311     (${BZIP2} -d -c $f | ${GZIP} > ${target}) || error "Could not create ${target}"
312   done
313 }
314
315 # Build diffs against an old release.
316 build_diffs() {
317   old_dir=${1%/*}
318   old_file=${1##*/}
319   old_vers=${old_file%.tar.bz2}
320   old_vers=${old_vers#gcc-}
321   inform "Building diffs against version $old_vers"
322   for f in gcc gcc-ada gcc-g++ gcc-g77 gcc-java gcc-objc gcc-testsuite gcc-core; do
323     old_tar=${old_dir}/${f}-${old_vers}.tar.bz2
324     new_tar=${WORKING_DIRECTORY}/${f}-${RELEASE}.tar.bz2
325     if [ ! -e $old_tar ]; then
326       inform "$old_tar not found; not generating diff file"
327     elif [ ! -e $new_tar ]; then
328       inform "$new_tar not found; not generating diff file"
329     else
330       build_diff $old_tar gcc-${old_vers} $new_tar gcc-${RELEASE} \
331         ${f}-${old_vers}-${RELEASE}.diff.bz2
332     fi
333   done
334 }
335
336 # Build an individual diff.
337 build_diff() {
338   changedir "${WORKING_DIRECTORY}"
339   tmpdir=gccdiff.$$
340   mkdir $tmpdir || error "Could not create directory $tmpdir"
341   changedir $tmpdir
342   (${BZIP2} -d -c $1 | ${TAR} xf - ) || error "Could not unpack $1 for diffs"
343   (${BZIP2} -d -c $3 | ${TAR} xf - ) || error "Could not unpack $3 for diffs"
344   ${DIFF} $2 $4 > ../${5%.bz2}
345   if [ $? -eq 2 ]; then
346     error "Trouble making diffs from $1 to $3"
347   fi
348   ${BZIP2} ../${5%.bz2} || error "Could not generate ../$5"
349   changedir ..
350   rm -rf $tmpdir
351   FILE_LIST="${FILE_LIST} $5"
352 }
353
354 # Upload the files to the FTP server.
355 upload_files() {
356   inform "Uploading files"
357
358   changedir "${WORKING_DIRECTORY}"
359
360   # Make sure the directory exists on the server.
361   if [ $LOCAL -eq 0 ]; then
362     ${SSH} -l ${GCC_USERNAME} ${GCC_HOSTNAME} \
363       mkdir -p "${FTP_PATH}/diffs"
364     UPLOAD_PATH="${GCC_USERNAME}@${GCC_HOSTNAME}:${FTP_PATH}"
365   else
366     mkdir -p "${FTP_PATH}/diffs" \
367       || error "Could not create \`${FTP_PATH}'"
368     UPLOAD_PATH=${FTP_PATH}
369   fi
370
371   # Then copy files to their respective (sub)directories.
372   for x in gcc*.gz gcc*.bz2; do
373     if [ -e ${x} ]; then
374       # Make sure the file will be readable on the server.
375       chmod a+r ${x}
376       # Copy it.
377       case ${x} in
378         *.diff.*)
379           SUBDIR="diffs/";
380           ;;
381         *)
382           SUBDIR="";
383       esac
384       ${SCP} ${x} ${UPLOAD_PATH}/${SUBDIR} \
385         || error "Could not upload ${x}"
386     fi
387   done
388 }
389
390 # Announce a snapshot, both on the web and via mail.
391 announce_snapshot() {
392   inform "Updating links and READMEs on the FTP server"
393   
394   TEXT_DATE=`date --date=$DATE +%B\ %d,\ %Y`
395   changedir "${SNAPSHOTS_DIR}"
396   sed -e "s%@DATE@%$DATE%g" \
397     -e "s%@TEXT_DATE@%$TEXT_DATE%g" \
398     -e "s%@LAST_DATE@%$LAST_DATE%g" \
399     -e "s%@BRANCH@%${BRANCH}%g" \
400     -e "s%@RELEASE@%${RELEASE}%g" \
401     -e "s%@EXPORT@%${EXPORTTAG} ${EXPORTDATE}%g" \
402     ~/scripts/snapshot-README > $$
403   mv $$ ${RELEASE}/README
404   sed -e "s%@DATE@%$DATE%g" \
405     -e "s%@TEXT_DATE@%$TEXT_DATE%g" \
406     -e "s%@LAST_DATE@%$LAST_DATE%g" \
407     -e "s%@BRANCH@%${BRANCH}%g" \
408     -e "s%@RELEASE@%${RELEASE}%g" \
409     -e "s%@EXPORT@%${EXPORTTAG} ${EXPORTDATE}%g" \
410     ~/scripts/snapshot-index.html > $$
411   mv $$ ${RELEASE}/index.html
412
413   touch LATEST-IS-${BRANCH}-${DATE}
414   rm -f LATEST-IS-${BRANCH}-${LAST_DATE}
415
416   inform "Sending mail"
417
418   export QMAILHOST=gcc.gnu.org
419   mail -s "gcc-ss-${RELEASE} is now available" gcc@gcc.gnu.org < ${SNAPSHOTS_DIR}/${RELEASE}/README
420 }
421
422 ########################################################################
423 # Initialization
424 ########################################################################
425
426 # Today's date.
427 DATE=`date "+%Y%m%d"`
428 LONG_DATE=`date "+%Y-%m-%d"`
429
430 # The CVS server containing the GCC repository.
431 CVS_SERVER="gcc.gnu.org"
432 # The path to the repository on that server.
433 CVS_REPOSITORY="/cvs/gcc"
434 # The CVS protocol to use.
435 CVS_PROTOCOL="ext"
436 # The username to use when connecting to the server.
437 CVS_USERNAME="${USER}"
438
439 # The machine to which files will be uploaded.
440 GCC_HOSTNAME="gcc.gnu.org"
441 # The name of the account on the machine to which files are uploaded.
442 GCC_USERNAME="gccadmin"
443 # The directory in which the files will be placed (do not use ~user syntax).
444 FTP_PATH=/var/ftp/pub/gcc
445 # The directory in which snapshots will be placed.
446 SNAPSHOTS_DIR=${FTP_PATH}/snapshots
447
448 # The major number for the release.  For release `3.0.2' this would be 
449 # `3'
450 RELEASE_MAJOR=""
451 # The minor number for the release.  For release `3.0.2' this would be
452 # `0'.
453 RELEASE_MINOR=""
454 # The revision number for the release.  For release `3.0.2' this would
455 # be `2'.
456 RELEASE_REVISION=""
457 # The complete name of the release.
458 RELEASE=""
459
460 # The name of the branch from which the release should be made, in a 
461 # user-friendly form.
462 BRANCH=""
463
464 # The name of the branch from which the release should be made, as used
465 # for our version control system.
466 CVSBRANCH=""
467
468 # The tag to apply to the sources used for the release.
469 TAG=""
470
471 # The old tarballs from which to generate diffs.
472 OLD_TARS=""
473
474 # The directory that will be used to construct the release.  The
475 # release itself will be placed in a subdirectory of this diretory.
476 DESTINATION=${HOME}
477 # The subdirectory.
478 WORKING_DIRECTORY=""
479 # The directory that will contain the GCC sources.
480 SOURCE_DIRECTORY=""
481
482 # The directories that should be part of the various language-specific
483 # tar files.  These are all relative to the top of the source tree.
484 ADA_DIRS="gcc/ada libada"
485 CPLUSPLUS_DIRS="gcc/cp libstdc++-v3"
486 FORTRAN_DIRS="gcc/f libf2c"
487 JAVA_DIRS="gcc/java libjava libffi fastjar zlib boehm-gc"
488 OBJECTIVEC_DIRS="gcc/objc libobjc"
489 TESTSUITE_DIRS="gcc/testsuite"
490
491 # Non-zero if this is the final release, rather than a prerelease.
492 FINAL=0
493
494 # Non-zero if we are building a snapshot, and don't build gcc or
495 # include generated files.
496 SNAPSHOT=0
497
498 # Non-zero if we are running locally on gcc.gnu.org, and use local CVS
499 # and copy directly to the FTP directory.
500 LOCAL=0
501
502 # Major operation modes.
503 MODE_GZIP=0
504 MODE_DIFFS=0
505 MODE_SOURCES=0
506 MODE_TARFILES=0
507 MODE_UPLOAD=0
508
509 # List of archive files generated; used to create .gz files from .bz2.
510 FILE_LIST=""
511
512 # Programs we use.
513
514 BZIP2="${BZIP2:-bzip2}"
515 CVS="${CVS:-cvs -f -Q -z9}"
516 DIFF="${DIFF:-diff -Nrc3pad}"
517 ENV="${ENV:-env}"
518 GZIP="${GZIP:-gzip --best}"
519 SCP="${SCP:-scp -p}"
520 SSH="${SSH:-ssh}"
521 TAR="${TAR:-tar}"
522
523 ########################################################################
524 # Command Line Processing
525 ########################################################################
526
527 # Parse the options.
528 while getopts "d:fr:u:t:p:s:l" ARG; do
529     case $ARG in
530     d)    DESTINATION="${OPTARG}";;
531     r)    RELEASE="${OPTARG}";;
532     t)    TAG="${OPTARG}";;
533     u)    CVS_USERNAME="${OPTARG}";;
534     f)    FINAL=1;;
535     s)    SNAPSHOT=1
536           BRANCH=${OPTARG%:*}
537           CVSBRANCH=${OPTARG#*:}
538           ;;
539     l)    LOCAL=1
540           SCP=cp
541           PATH=~:/usr/local/bin:$PATH;;
542     p)    OLD_TARS="${OLD_TARS} ${OPTARG}"
543           if [ ! -f ${OPTARG} ]; then
544             error "-p argument must name a tarball"
545           fi;;
546     \?)   usage;;
547     esac
548 done
549 shift `expr ${OPTIND} - 1`
550
551 # Handle the major modes.
552 while [ $# -ne 0 ]; do
553     case $1 in
554     diffs)    MODE_DIFFS=1;;
555     gzip)     MODE_GZIP=1;;
556     sources)  MODE_SOURCES=1;;
557     tarfiles) MODE_TARFILES=1;;
558     upload)   MODE_UPLOAD=1;;
559     all)      MODE_SOURCES=1; MODE_TARFILES=1; MODE_DIFFS=1; MODE_UPLOAD=1;
560               if [ $SNAPSHOT -ne 1 ]; then
561                 # Only for releases and pre-releases.
562                 MODE_GZIP=1;
563               fi
564               ;;
565     *)        error "Unknown mode $1";;
566     esac
567     shift
568 done
569
570 # Perform consistency checking.
571 if [ ${LOCAL} -eq 0 ] && [ -z ${CVS_USERNAME} ]; then
572   error "No username specified"
573 fi
574
575 if [ ! -d ${DESTINATION} ]; then
576   error "\`${DESTINATION}' is not a directory"
577 fi
578
579 if [ $SNAPSHOT -eq 0 ]; then
580   if [ -z ${RELEASE} ]; then
581     error "No release number specified"
582   fi
583
584   # Compute the major and minor release numbers.
585   RELEASE_MAJOR=`echo $RELEASE | awk --assign FS=. '{ print $1; }'`
586   RELEASE_MINOR=`echo $RELEASE | awk --assign FS=. '{ print $2; }'`
587   RELEASE_REVISION=`echo $RELEASE | awk --assign FS=. '{ print $3; }'`
588
589   if [ -z "${RELEASE_MAJOR}" ] || [ -z "${RELEASE_MINOR}" ]; then
590     error "Release number \`${RELEASE}' is invalid"
591   fi
592
593   # Compute the full name of the release.
594   if [ -z "${RELEASE_REVISION}" ]; then
595     RELEASE="${RELEASE_MAJOR}.${RELEASE_MINOR}"
596   else
597     RELEASE="${RELEASE_MAJOR}.${RELEASE_MINOR}.${RELEASE_REVISION}"
598   fi
599
600   # Compute the name of the branch, which is based solely on the major
601   # and minor release numbers.
602   CVSBRANCH="gcc-${RELEASE_MAJOR}_${RELEASE_MINOR}-branch"
603
604   # If this is not a final release, set various parameters acordingly.
605   if [ ${FINAL} -ne 1 ]; then
606     RELEASE="${RELEASE}-${DATE}"
607     FTP_PATH="${FTP_PATH}/prerelease-${RELEASE}/"
608   else
609     FTP_PATH="${FTP_PATH}/releases/gcc-${RELEASE}/"
610   fi
611 else
612   RELEASE=${BRANCH}-${DATE}
613   FTP_PATH="${FTP_PATH}/snapshots/${RELEASE}"
614   if [ ${CVSBRANCH} != "HEAD" ]; then
615     TAG=gcc-ss-`echo ${RELEASE} | tr '.' '_'`
616   fi
617
618   # If diffs are requested when building locally on gcc.gnu.org, we (usually)
619   # know what the last snapshot date was and take the corresponding tarballs,
620   # unless the user specified tarballs explictly.
621   if [ $MODE_DIFFS -ne 0 ] && [ $LOCAL -ne 0 ] && [ -z "${OLD_TARS}" ]; then
622     LAST_DATE=`cat ~/.snapshot_date-${BRANCH}`
623     OLD_TARS=${SNAPSHOTS_DIR}/${BRANCH}-${LAST_DATE}/gcc-${BRANCH}-${LAST_DATE}.tar.bz2
624   fi
625 fi
626
627 # Compute the name of the WORKING_DIRECTORY and the SOURCE_DIRECTORY.
628 WORKING_DIRECTORY="${DESTINATION}/gcc-${RELEASE}"
629 SOURCE_DIRECTORY="${WORKING_DIRECTORY}/gcc-${RELEASE}"
630
631 # Recompute the names of all the language-specific directories,
632 # relative to the WORKING_DIRECTORY.
633 ADA_DIRS=`adjust_dirs ${ADA_DIRS}`
634 CPLUSPLUS_DIRS=`adjust_dirs ${CPLUSPLUS_DIRS}`
635 FORTRAN_DIRS=`adjust_dirs ${FORTRAN_DIRS}`
636 JAVA_DIRS=`adjust_dirs ${JAVA_DIRS}`
637 OBJECTIVEC_DIRS=`adjust_dirs ${OBJECTIVEC_DIRS}`
638 TESTSUITE_DIRS=`adjust_dirs ${TESTSUITE_DIRS}`
639
640 # Set up CVSROOT.
641 if [ $LOCAL -eq 0 ]; then
642     CVSROOT=":${CVS_PROTOCOL}:${CVS_USERNAME}@"
643     CVSROOT="${CVSROOT}${CVS_SERVER}:${CVS_REPOSITORY}"
644 else
645     CVSROOT="${CVS_REPOSITORY}"
646 fi
647 export CVSROOT
648
649 ########################################################################
650 # Main Program
651 ########################################################################
652
653 # Set the timezone to UTC
654 TZ="UTC0"
655 export TZ
656
657 # Build the source directory.
658
659 if [ $MODE_SOURCES -ne 0 ]; then
660   build_sources
661 fi
662
663 # Build the tar files.
664
665 if [ $MODE_TARFILES -ne 0 ]; then
666   build_tarfiles
667 fi
668
669 # Build diffs
670
671 if [ $MODE_DIFFS -ne 0 ]; then
672   # Possibly build diffs.
673   if [ -n "$OLD_TARS" ]; then
674     for old_tar in $OLD_TARS; do
675       build_diffs $old_tar
676     done
677   fi
678 fi
679
680 # Build gzip files
681 if [ $MODE_GZIP -ne 0 ]; then
682   build_gzip
683 fi
684
685 # Upload them to the FTP server.
686
687 if [ $MODE_UPLOAD -ne 0 ]; then
688   upload_files
689
690   # For snapshots, make some further updates.
691   if [ $SNAPSHOT -ne 0 ] && [ $LOCAL -ne 0 ]; then
692     announce_snapshot
693
694     # Update snapshot date file.
695     changedir ~
696     echo $DATE > .snapshot_date-${BRANCH}
697
698     # Remove working directory
699     rm -rf ${WORKING_DIRECTORY}
700   fi
701 fi